package ru.amse.bazylevich.faeditor.fautomaton.file;

import java.io.File;
import java.io.IOException;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.SAXException;

import ru.amse.bazylevich.faeditor.fautomaton.IAutomaton;
import ru.amse.bazylevich.faeditor.fautomaton.impl.Automaton;

public class AutomatonLoader implements IAutomatonLoader {
	
	private final SAXParser myParser;
	
	public AutomatonLoader() throws SAXException , ParserConfigurationException {
		SAXParserFactory f = SAXParserFactory.newInstance();
		myParser = f.newSAXParser();
	}
	
	public IAutomaton load(File file) throws SAXException, IOException {
		IAutomaton automaton = new Automaton();
		myParser.parse(file , new AutomatonLoaderHandler(automaton));
		return automaton;
	}
	

}
