package ru.amse.bazylevich.faeditor.ui.fautomaton;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.AbstractButton;
import javax.swing.JCheckBox;
import javax.swing.JPopupMenu;

import ru.amse.bazylevich.faeditor.fautomaton.IAutomaton;
import ru.amse.bazylevich.faeditor.fautomaton.IState;

public class JTypeOfStateMenu extends JPopupMenu {
	
	private final JFAutomaton myJFAutomaton;
	private IState myState;
	private final JCheckBox myInitialButton;
	private final JCheckBox myFinalButton;
	private IAutomaton myAutomaton;
	
	
	public JTypeOfStateMenu(JFAutomaton jFAutomaton) {
		myJFAutomaton = jFAutomaton;
		//final IAutomaton automaton = myJFAutomaton.getAutomatonPresentation().getAutomaton();
		myInitialButton = new JCheckBox("initial");
		myInitialButton.setAction(new AbstractAction("initial") {
			@Override
			public void actionPerformed(ActionEvent e) {
				if (myState != null) {
					AbstractButton abstractButton = (AbstractButton) e.getSource();
				    boolean selected = abstractButton.getModel().isSelected();
					if (selected) {
						myAutomaton.toInitialState(myState);
					} else {
						myAutomaton.toInitialState(null);
					}
					myJFAutomaton.fireComponentChanged();
					myJFAutomaton.repaint();
				}

			}
		});
		myFinalButton = new JCheckBox("final");
		myFinalButton.setAction(new AbstractAction("final") {
			@Override
			public void actionPerformed(ActionEvent e) {
				if (myState != null) {
					AbstractButton abstractButton = (AbstractButton) e.getSource();
				    boolean selected = abstractButton.getModel().isSelected();
					if (selected) {
						myAutomaton.addFinalState(myState);
					} else {
						myAutomaton.removeFromFinalStates(myState);
					}
					myJFAutomaton.fireComponentChanged();
					myJFAutomaton.remove(JTypeOfStateMenu.this);
					myJFAutomaton.repaint();
				}
			}
		});
		add(myInitialButton);
		add(myFinalButton);
	}
	
	
	public void setState(IState state) {
		myState = state;
		myAutomaton = myJFAutomaton.getAutomatonPresentation().getAutomaton();
		if (myState == null) {
			myFinalButton.setEnabled(false);
			myInitialButton.setEnabled(false);
			myFinalButton.setSelected(false);
			myInitialButton.setSelected(false);
		} else {
			myFinalButton.setEnabled(true);
			myInitialButton.setEnabled(true);
			IAutomaton automaton = myJFAutomaton.getAutomatonPresentation().getAutomaton();
			myFinalButton.setSelected(automaton.getFinalStates().contains(myState));
			myInitialButton.setSelected(automaton.getInitialState() == myState);
		}
	}
	
}
