package ru.amse.bazylevich.faeditor.ui.fautomaton.draw.util;

import ru.amse.bazylevich.faeditor.ui.fautomaton.draw.impl.AutomatonDrawer;
import ru.amse.bazylevich.faeditor.ui.fautomaton.util.Point;

public class Geometry {
	
	
	public static Point computingEdgeEnd(int x, int y) {
		Point point = new Point();
		if (x == 0) {
			if (y > 0) {
				point.setY(AutomatonDrawer.MYSTATEHEIGHT / 2);
			} else if (y < 0) {
				point.setY(-AutomatonDrawer.MYSTATEHEIGHT / 2);
			} 
			return point;
		}
		if (y == 0) {
			if (x > 0) {
				point.setX(AutomatonDrawer.MYSTATEWIDTH / 2);
			} else {
				point.setX(- AutomatonDrawer.MYSTATEWIDTH / 2);
			}
			return point;
		}
		
		double heightPowTwo = Math.pow(AutomatonDrawer.MYSTATEHEIGHT / 2, 2);
		double widthPowTwo = Math.pow(AutomatonDrawer.MYSTATEWIDTH / 2, 2);

		double k = ((double) y/ x); 
		double a = heightPowTwo + widthPowTwo * k * k;
		double c = heightPowTwo * widthPowTwo;
		
		double root1 = Math.pow(c / a, 0.5);
		double root2 = - root1;
		if (x > 0) {
			point.setX( ((int)(root1 + 0.5)) );
			point.setY( ((int) ((root1 * k) + 0.5)) ); 
		} else {
			point.setX( ((int) (root2 + 0.5)) );
			point.setY( ((int) ((root2 * k) + 0.5)) ); 
		}
		return point;
	}
	
	public static Point computingEdgeEnd(Point start, Point end) {
		int x1 = end.getX() - start.getX();
		int y1 = end.getY() - start.getY();
		Point point = Geometry.computingEdgeEnd(x1, y1);
		point.addX(start.getX());
		point.addY(start.getY());
		return point;
	}
	
	public static double calculatingAngel(Point start, Point end) {
		double theta;
		if (start.getX() == end.getX()) {
			if (start.getY() > end.getY()) {
				theta = Math.PI / 2;
			} else {
				theta = -Math.PI / 2;
			}
		} else {
			theta = Math.atan((double) (end.getY() - start.getY()) / (end.getX() - start.getX()));
		}
		return theta;
	}

}
