package ru.amse.bazylevich.faeditor.ui.fautomaton.file;

import java.io.File;
import java.io.IOException;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.SAXException;

import ru.amse.bazylevich.faeditor.fautomaton.IAutomaton;
import ru.amse.bazylevich.faeditor.fautomaton.file.AutomatonLoaderHandler;
import ru.amse.bazylevich.faeditor.fautomaton.impl.Automaton;
import ru.amse.bazylevich.faeditor.ui.fautomaton.IAutomatonPresentation;
import ru.amse.bazylevich.faeditor.ui.fautomaton.impl.AutomatonPresentation;


public class AutomatonPresentationLoader implements IAutomatoPresentationnLoader {

	private final SAXParser myParser;
	
	public AutomatonPresentationLoader() throws SAXException , ParserConfigurationException {
		SAXParserFactory f = SAXParserFactory.newInstance();
		myParser = f.newSAXParser();
	}
	
	public IAutomatonPresentation load(File file) throws SAXException, IOException {
		IAutomaton automaton = new Automaton();
		myParser.parse(file, new AutomatonLoaderHandler(automaton));
		IAutomatonPresentation automatonPresentation = new AutomatonPresentation(automaton);
		myParser.parse(file, new AutomatonPresentationLoaderHandler(automatonPresentation));
		return automatonPresentation;
	}
	
}
