package ru.amse.bazylevich.faeditor.ui.fautomaton.tools.impl;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.MouseEvent;

import ru.amse.bazylevich.faeditor.fautomaton.impl.State;
import ru.amse.bazylevich.faeditor.ui.fautomaton.IStatePresentation;
import ru.amse.bazylevich.faeditor.ui.fautomaton.JFAutomaton;
import ru.amse.bazylevich.faeditor.ui.fautomaton.draw.impl.AutomatonDrawer;
import ru.amse.bazylevich.faeditor.ui.fautomaton.impl.StatePresentation;
import ru.amse.bazylevich.faeditor.ui.fautomaton.tools.ITool;
import ru.amse.bazylevich.faeditor.ui.fautomaton.util.AutomatonPresentatios;
import ru.amse.bazylevich.faeditor.ui.fautomaton.util.Point;
import ru.amse.bazylevich.faeditor.ui.fautomaton.util.impl.StateLabelParser;

public class AddVertexState implements ITool {
	
	private IStatePresentation myState;
	private final JFAutomaton myJFAutomaton;
	private boolean myIsVisible;

	public AddVertexState(JFAutomaton jFAutomaton) {
		myJFAutomaton = jFAutomaton;
		myState = new StatePresentation(new State("new"), 0, 0);
		myIsVisible = true;
	}
	
	@Override
	public void finishDrawing(Graphics gc) {
		if (myIsVisible) {
			((Graphics2D) gc).setStroke(
				       new BasicStroke(
				               1.3f,
				               BasicStroke.CAP_ROUND,
				               BasicStroke.JOIN_ROUND,
				               1.0f,
				               new float[]{3,4},
				               0
				       )
			);
			if (myState.getX() != 0 && myState.getY() != 0) {
				myJFAutomaton.getDraw().drawState(myState, gc);
			}
		}
		gc.setColor(Color.GRAY);
		for (IStatePresentation state : myJFAutomaton.getAutomatonPresentation().getStatesPresentations()) {
			gc.fillRoundRect(state.getX() + AutomatonDrawer.MYSTATEWIDTH / 2 - JFAutomaton.MYWIDTH / 2, state.getY() - JFAutomaton.MYWIDTH / 2, JFAutomaton.MYWIDTH, JFAutomaton.MYWIDTH, JFAutomaton.MYWIDTH / 2, JFAutomaton.MYWIDTH /2);
		}
		
	}
	
	@Override
	public void mouseClicked(MouseEvent event) {
		myJFAutomaton.fireComponentChanged();
		Point point = new Point(event.getX(), event.getY());
		myState.setX(event.getX());
		myState.setY(event.getY());
		myJFAutomaton.getAutomatonPresentation().getAutomaton().addState(myState.getState());
		myJFAutomaton.getAutomatonPresentation().addStatePresentation(myState);
		myJFAutomaton.getLabelEditor().setParser(new StateLabelParser(myState.getState()), point);
		myJFAutomaton.add(myJFAutomaton.getLabelEditor());
		myJFAutomaton.getLabelEditor().requestFocusInWindow();
		myState = new StatePresentation(new State("new"), event.getX(), event.getY());
		
		myJFAutomaton.repaint();
	}
	
	@Override
	public void mouseDragged(MouseEvent event) {
		// TODO Auto-generated method stub
		
	}
	
	@Override
	public void mouseMoved(MouseEvent event) {
		Point point = new Point(event.getX(), event.getY());
		IStatePresentation state = AutomatonPresentatios.searchSideState(point, myJFAutomaton.getAutomatonPresentation());
		myIsVisible = (state == null);
		myState.setX(event.getX());
		myState.setY(event.getY());
		myJFAutomaton.repaint();
	}
	
	@Override
	public void mousePressed(MouseEvent event) {
		// TODO Auto-generated method stub
		
	}
	
	@Override
	public void mouseReleased(MouseEvent event) {
		// TODO Auto-generated method stub
		
	}
}
