package ru.amse.bazylevich.faeditor.ui.fautomaton.tools.impl;

import java.awt.Graphics;
import java.awt.event.MouseEvent;

import ru.amse.bazylevich.faeditor.ui.fautomaton.IStatePresentation;
import ru.amse.bazylevich.faeditor.ui.fautomaton.JFAutomaton;
import ru.amse.bazylevich.faeditor.ui.fautomaton.tools.ITool;
import ru.amse.bazylevich.faeditor.ui.fautomaton.tools.util.RectangleDrawer;
import ru.amse.bazylevich.faeditor.ui.fautomaton.util.AutomatonPresentatios;
import ru.amse.bazylevich.faeditor.ui.fautomaton.util.Point;

public class DrawRectangleState implements ITool {
	
	private final JFAutomaton myJFAutomaton;
	private Point myLeftRectangleVertex;
	private Point myRigthRectangleVertex;
	
	public DrawRectangleState(JFAutomaton jFAutomaton)  {
		myJFAutomaton = jFAutomaton;
	}
	
	@Override
	public void mouseClicked(MouseEvent mEvent) {
		myJFAutomaton.setSelectedTransition(null);
		IStatePresentation state = AutomatonPresentatios.searchStatePresentation(myJFAutomaton.getAutomatonPresentation(), new Point(mEvent.getX(), mEvent.getY()));
		if (state != null) {
			myJFAutomaton.addSelectedState(state);
			myJFAutomaton.getTypeOfStateChooser().setState(state.getState());
		} else {
			myJFAutomaton.getTypeOfStateChooser().setState(null);
		}
		if (myJFAutomaton.getSelectedStates().size() != 0) {
			myJFAutomaton.fireElementsSelected();
		} else {
			myJFAutomaton.fireElementsUnselected();
		}
	}
	
	@Override
	public void mousePressed(MouseEvent mEvent) {
		myRigthRectangleVertex = new Point(mEvent.getX(), mEvent.getY());
		myJFAutomaton.clearSelectedStates();
		myJFAutomaton.setSelectedTransition(null);
	}
	
	@Override
	public void mouseDragged(MouseEvent mEvent) {
		myLeftRectangleVertex = new Point(mEvent.getX(), mEvent.getY());
		if (myRigthRectangleVertex != null) {
			myJFAutomaton.setSelectedStates(AutomatonPresentatios.getStateInRectangle(myJFAutomaton.getAutomatonPresentation(),RectangleDrawer.getLeftRectangleVertex(myRigthRectangleVertex, myLeftRectangleVertex), RectangleDrawer.getRightRectangleVertex(myRigthRectangleVertex, myLeftRectangleVertex)));
		}
	}
	
	@Override
	public void mouseReleased(MouseEvent mEvent) {
		if (myRigthRectangleVertex != null && myLeftRectangleVertex != null) {
			myJFAutomaton.setSelectedStates(AutomatonPresentatios.getStateInRectangle(myJFAutomaton.getAutomatonPresentation(),RectangleDrawer.getLeftRectangleVertex(myRigthRectangleVertex, myLeftRectangleVertex), RectangleDrawer.getRightRectangleVertex(myRigthRectangleVertex, myLeftRectangleVertex)));
			myLeftRectangleVertex = null;
			myRigthRectangleVertex = null;
			myJFAutomaton.repaint();
		}
		if (myJFAutomaton.getSelectedStates().size() != 0) {
			myJFAutomaton.fireElementsSelected();
		} else {
			myJFAutomaton.fireElementsUnselected();
		}
	}
	
	
	public void finishDrawing(Graphics gc) {
		if ((myLeftRectangleVertex != null) && (myRigthRectangleVertex != null)) {
			RectangleDrawer.drawRectangle(myLeftRectangleVertex, myRigthRectangleVertex, gc);
		}
	}
	
	@Override
	public void mouseMoved(MouseEvent event) {
		// TODO Auto-generated method stub
		
	}

}
