package ru.amse.bazylevich.faeditor.ui.fautomaton.util.impl;

import ru.amse.bazylevich.faeditor.fautomaton.ITransition;
import ru.amse.bazylevich.faeditor.ui.fautomaton.util.ConditionParser;
import ru.amse.bazylevich.faeditor.ui.fautomaton.util.IParser;
import ru.amse.bazylevich.faeditor.ui.fautomaton.util.exceptions.IncorrectStringException;


public class TransitionParser implements IParser {
	
	private final ITransition myTransition;
	
	public TransitionParser(ITransition transition) {
		myTransition = transition;
	}
	
	@Override
	public void setNewValue(String string) throws IncorrectStringException {
		myTransition.setCondition(ConditionParser.readCondition(string));
	}
	
	@Override
	public String getString() {
		return myTransition.getCondition().toString();
	}

}
