package ru.amse.bazylevich.faeditor.ui.interpreter;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;

import javax.swing.JComponent;
import javax.swing.border.EtchedBorder;

public class JDrawString extends JComponent {
	
	private final static String MYISACCEPTEDSTRING =  "This string is accepted :  ";
	private final static String MYISNOTACCEPTEDSTRING = "This string isn't accepted :  ";
	
	private int myStep;
	private String myString;
	private String myIsAccepted;
	
	public JDrawString() {
		setBorder(new EtchedBorder());
	}

	public void setString(String str) {
		myString = str;
		myStep = -1;
		repaint();
	}
	
	public void setIsAcceptedString(boolean isAccepted) {
		if (isAccepted) {
			myIsAccepted = MYISACCEPTEDSTRING;
		} else {
			myIsAccepted = MYISNOTACCEPTEDSTRING;
		}
	}
	
	public void incStep() {
		myStep++;
		repaint();
	}
	
	public void decStep() {
		myStep--;
		repaint();
	}
	
	@Override
	protected void paintComponent(Graphics g) {
		((Graphics2D) g).setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		
		if (myString != null) {
			int x = getWidth() / 2 - g.getFontMetrics().stringWidth(myIsAccepted + myString) / 2;
			int y = getHeight() / 2 + 5;
			g.drawString(myIsAccepted, x, y);
			x += g.getFontMetrics().stringWidth(myIsAccepted);
			if (myStep == -1) {
				g.drawString(myString, x, y);
			} else {
				String begin = myString.substring(0, myStep);
				String letter = ((Character) myString.charAt(myStep)).toString();
				String end = myString.substring(myStep + 1);
				g.drawString(begin, x, y);
				x += g.getFontMetrics().stringWidth(begin);
				g.setColor(Color.RED);
				g.drawString(letter, x, y);
				g.setColor(Color.BLACK);
				x += g.getFontMetrics().stringWidth(letter);
				g.drawString(end, x, y);
			}
		}
	}
}
