package ru.amse.bazylevich.faeditor.ui.menuactions;

import java.awt.event.ActionEvent;
import java.util.LinkedHashSet;
import java.util.Set;

import javax.swing.AbstractAction;

import ru.amse.bazylevich.faeditor.fautomaton.IAutomaton;
import ru.amse.bazylevich.faeditor.fautomaton.IState;
import ru.amse.bazylevich.faeditor.fautomaton.algorithms.MinimizerAutomaton;
import ru.amse.bazylevich.faeditor.main.MainFrame;
import ru.amse.bazylevich.faeditor.ui.fautomaton.IStatePresentation;
import ru.amse.bazylevich.faeditor.ui.fautomaton.JFAutomaton;
import ru.amse.bazylevich.faeditor.ui.fautomaton.impl.AutomatonPresentation;
import ru.amse.bazylevich.faeditor.ui.fautomaton.util.AutomatonPresentatios;

public class MinimizeAction extends AbstractAction {

	private final JFAutomaton myJFAutomaton;
	private final MainFrame myMainFrame;
	
	public MinimizeAction(JFAutomaton jFAutomaton, MainFrame mainFrame) {
		super("Minimize");
		myJFAutomaton = jFAutomaton;
		myMainFrame = mainFrame;
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
		myJFAutomaton.fireComponentChanged();
		if (myMainFrame.showSaveDialog(e)) {
			IAutomaton automaton = MinimizerAutomaton.minimize(myJFAutomaton.getAutomatonPresentation().getAutomaton());
			myJFAutomaton.setAutomaton(new AutomatonPresentation(automaton, makeStatePresentations(automaton)));
			myMainFrame.setAsked();
			myJFAutomaton.repaint();
		}
	}
	
	private Set<IStatePresentation> makeStatePresentations(IAutomaton automaton) { 
		Set<IStatePresentation> set = new LinkedHashSet<IStatePresentation>();
		for (IState state : automaton.getStates()) {
			set.add(AutomatonPresentatios.getStatePresentation(myJFAutomaton.getAutomatonPresentation(), state));
		}
		return set;
	}
}
